# afbackup-lib.pl
# Common functions for afbackup config files

do '../web-lib.pl';
&init_config();

# get_conf (conf-file, conf-option)
#
sub get_backup_conf_value {
    my ($conf_file, $option) = @_;
    #print "suche in: $conf_file nach: $option\n<br>";

    $conf = &read_file_lines($conf_file);

    #my $foundit = "nicht gefunden :-(\n<br>";

    foreach $cline (@$conf) {
        if ($cline =~ /^(#?)$option:[\s]+(.*)/ ) {
            if ($1 eq "#") {
                @rv = ($2, "not set");
            } else {
                @rv = ($2, "set");
            }
    #        $foundit = "gefunden!\n<br>";
            last;
        }
    }
    #print $foundit;

    return @rv;
}


# save_options(%options)
#
sub save_options {

    my %options = %{$_[0]};

    my $conf_file = $options{"Conf_File"};

    my $conf = &read_file_lines($conf_file);
    my @cache = @$conf;

    $i=0;
    foreach $cline ( @cache ) {

        if ($cline =~ /^(#?)([\w \-]+):[\s]+(.*)/ ) {

            if (exists $options{$2} ) {
                $cline = ( $options{"set_".$2} eq "set") ? "" : "#";
                $cline .= $2.":\t\t".$options{$2};
                splice(@cache, $i, 1, $cline );
            }
        }
        $i++;
    }
    @$conf = @cache;
    &flush_file_lines();
}


sub get_client_list {
	return &get_conf_list( $config{'optionC'}, '\.conf');
}

sub get_server_list {
	return &get_conf_list( $config{'optionS'}, '\.conf');
}

sub get_run_list {
	return &get_conf_list( $config{'optionS'}, '\.run');
}

sub get_conf_list {
	($conf_dir, $filter) = @_;
	my @confs;
	opendir DIR, $conf_dir or die "Can't open directory $conf_dir: $!\n";
	my @files= grep /$filter$/ , readdir(DIR);
	foreach my $conf_file (@files) {
        $conf_file =~  /(.*)$filter/ ;
        push (@confs ,$1);
	}
	return @confs;
}
####################
#
# Lable Disk Volumes
#
# system("/usr/local/afbackup/server/bin/labeltape $i -n<labeled by webmin-module> -d$data_cand -b1024 -s$set_file_cmd ");
#       label_tape <label-number> [ -rfF ] [ -c <configfile> ] \
#            [ -S <sec-label-number ] [ -n <comment> ] \
#            [ -d <devicename> ] [ -b <blocksize> ] \
#            [ -s <set-file-cmd> ] [ -C <num-cartridges> ]


sub label_disk_vol {
  ($filename, $label, $scnd_label, $block_size) = @_;

  # print "Label File: $filename -> $label";
  my $actimestr = localtime();
  my $versiontext = '3.3.3';
  my $comment ='<labeled by webmin-modul>';

  $whatfailed = 'Dateifehler';
  if (! open(SCHREIBEN,"> $filename")) { &error ("Fehler beim Anlegen von ".$filename.": !"); exit};
  print SCHREIBEN
    "\n".
    "AF's backup system\n\n".
    "INFO HEADER\n\n".
    "Cartridge number:\t".$label."\n\n".
    "2nd cartridge number:\t".$scnd_label."\n\n".
#    "Copy from:\t\t\n\n".
    "Labeling time:\t\t".$actimestr."\n\n".
    "Tape Blocksize:\t\t".$block_size."\n\n".
#    "Duplicating time:\t\n".
    "Program version:\t".$versiontext."\n\n".
    "Comment:\t\t".$comment."\n" ;

  local $i = tell (SCHREIBEN);
  for (; $i < $block_size; $i++ ) { print SCHREIBEN "\0" };

  close(SCHREIBEN);

}

#################################
#
# convert NumSets to sorted Lists
#
sub numset2list {
  my $numset = shift;
  my @list = split ( /,/ , $numset );
  my @rv =();
  foreach $n (@list) {
    if ( $n =~ /(\d+)-(\d+)/ ) {
      for $i ($1 .. $2) { push(@rv, $i) };
    } elsif ( $n =~ /(\d+)/ ){
      push (@rv, $1);
    }
  }
  return sort { $a <=> $b } @rv;
}

#
# check if number is in tapeset
#
sub isinset {
  ($set, $n) = @_;
  my $rv = 0;
  foreach $i (&numset2list($set)) { $rv ||= (($i eq $n) || ($i == $n)) };
  return $rv;
}

#