#!/usr/bin/perl
#
#    AFBackup Config and Mantainance Module
#    Copyright (C) 1999 by Dirk Wallmeier
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    This module inherited from the Webmin Module Template 0.79.1 by tn

require './afbackup-lib.pl';
$|=1;
&init_config("afbackup");

%access=&get_module_acl;

## put in ACL checks here if needed


## sanity checks



&header("AFBackup", "", "AFs_Intro", 1, 1, undef,
        "Written by<BR><A HREF=mailto:Dirk.Wallmeier\@gmx.de>Dirk Wallmeier</A><BR><A HREF=http://www.dwallmeier.gmxhome.de>Home://page</A>");
# uses the index_title entry from ./lang/en or appropriate

## Insert Output code here
print "<hr>\n";

$conf_dir = $config{'optionC'};
print "<h3>Clients found in <i>$conf_dir</i> :</h3>\n";

foreach $client (&get_client_list) {
        push( @client_links  , "client.cgi?client=$client.conf" );
        push( @client_titles , "$client" );
        push( @client_icons  , "images/icon-client.gif" );
}

&icons_table(\@client_links, \@client_titles, \@client_icons);
print "<a href=create_new_client.cgi>create a new client</a> &nbsp; &nbsp; &nbsp; &nbsp;";
print "<a href=delete_client.cgi>delete a client</a>";
print "<hr>\n";

$conf_dir = $config{'optionS'};
print "<h3>Server found in <i>$conf_dir</i> :</h3>\n";

foreach $server (&get_server_list) {
        if ( $server !~ /changer/g ) {
            push( @server_links  , "server.cgi?server=$server.conf" );
            push( @server_titles , $server );
            push( @server_icons  , "images/icon-server.gif" );
        } else {
            push( @changer_links  , "changer.cgi?changer=changer.conf" );
            push( @changer_titles , "Changer Conf" );
            push( @changer_icons  , "images/icon-changer.gif" );
        }
}
&icons_table(\@server_links, \@server_titles, \@server_icons);
print "<a href=create_new_server.cgi>create new server</a>";
print "<hr>\n";

print "<h3>Tape Handling :</h3>";

push( @changer_links  , "disk_cache.cgi" );
push( @changer_titles , "Disk Cache" );
push( @changer_icons  , "images/icon-cache.gif" );

&icons_table(\@changer_links, \@changer_titles, \@changer_icons);
print "<hr>\n";

print "<h3>Scheduling :</h3>";

push( @scheduler_links  , "scheduler.cgi" );
push( @scheduler_titles , "Scheduler" );
push( @scheduler_icons  , "images/icon-scheduler.gif" );

&icons_table(\@scheduler_links, \@scheduler_titles, \@scheduler_icons);
print "<hr>\n";

&footer("/", $text{'index'});
# uses the index entry in /lang/en



## if subroutines are not in an extra file put them here


### END of index.cgi ###.
