package java_revs;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;
import java.util.Vector;
//import java.lang.Math.*;

public class revs extends Applet implements Runnable {
  boolean isStandalone = false;

  Thread revsrunner = null;    // The thread that displays images
  int delay = 1000;            // the delay time between blinks

  private Image revsImage;
  private Image revs_nabeImage;

  InputStream   revsIS;
  String URLstring;

  double statusSpeed;
  double statusAccel;
  double statusPos;

  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public revs() {
  }


  //Initialize the applet
  public void init() {
    try {
      //var0 = this.getParameter("param0", "");
      revsImage = getImage(getDocumentBase(), getParameter("revsGIF"));
      revs_nabeImage = getImage(getDocumentBase(), "revs_nabe.gif");
      URLstring = this.getParameter("cgiURL") + "?rand=";

    }
    catch(Exception e) {
      e.printStackTrace();
    }


    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    this.setBackground(SystemColor.controlText);
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    String[][] pinfo =
      {
      {"cgiURL", "String", ""},
      {"revsGIF", "String", ""},
      {"tapepos", "String", ""},
      };
    return pinfo;
  }

  // starten
  public void start() {
    revsrunner = new Thread(this);
    revsrunner.start();
  }

  public void stop() {
    revsrunner = null;
  }

  public void run() {
    Thread me = Thread.currentThread();
    while (revsrunner == me) {
      try {
        Thread.currentThread().sleep(delay);
      } catch (InterruptedException e) {
        System.out.println("...luft nicht");
      }
      getStatusCGI();
      repaint();
    }
  }


  public void paint(Graphics g) {
    g.drawImage(revsImage, 0,0, 380, 380, this);

    double w0 = -20;
    double w8 = 200;
    double r0 = 0;
    double r8 = 800;

    double r = statusSpeed;
    double wGrad = w0 + ( r - r0 ) / ( r8 - r0) *(w8 - w0);
    double w = java.lang.Math.PI * wGrad / 180;

    int R = 190 - 70;
    int x0 = 190;
    int y0 = 190;

    double xN = x0 - R * java.lang.Math.cos(w);
    double yN = y0 - R * java.lang.Math.sin(w);
    double xB = - java.lang.Math.sin(w);
    double yB = java.lang.Math.cos(w);

    int[] xNadel = {(int)java.lang.Math.round(x0-5*xB),
                     (int)java.lang.Math.round(xN-2*xB),
                     (int)java.lang.Math.round(xN),
                     (int)java.lang.Math.round(xN+2*xB),
                     (int)java.lang.Math.round(x0+5*xB)};
    int[] yNadel = {(int)java.lang.Math.round(y0-5*yB),
                     (int)java.lang.Math.round(yN-2*yB),
                     (int)java.lang.Math.round(yN),
                     (int)java.lang.Math.round(yN+2*yB),
                     (int)java.lang.Math.round(y0+5*yB)};
    Polygon nadel = new Polygon (xNadel, yNadel, 5);
/*  int[] xNadel = {(int)java.lang.Math.round(x0-5),
                     (int)java.lang.Math.round(xN),
                     (int)java.lang.Math.round(x0+5)};
    int[] yNadel = {(int)java.lang.Math.round(y0),
                     (int)java.lang.Math.round(yN),
                     (int)java.lang.Math.round(y0)};
    Polygon nadel = new Polygon (xNadel, yNadel, 3);
*/    g.setColor (Color.red);
    g.fillPolygon( nadel);

    //g.drawImage(revs_nabeImage, 190-33, 190-38, this);
    g.drawImage(revs_nabeImage, 0, 0, this);

    g.setColor (Color.orange);
    g.setFont(new Font("Helvetica", Font.BOLD, 18));
    //g.drawString(getParameter("tapepos"), 150, 290);

    //Double sp = new Double(statusSpeed);
    g.drawString( Double.toString(wGrad) , 150, 290);
    System.out.println ("Speed: " + Double.toString(statusSpeed));

  }

  private void getStatusCGI() {

    long now = System.currentTimeMillis();
    try {
      URL revsURL = new URL(URLstring + now );
      //System.out.println("get : " + revsURL.getFile() );

      try {
        Vector token = new Vector();
        revsIS = revsURL.openStream();
        StreamTokenizer revsST = new StreamTokenizer( revsIS );
          while (revsST.nextToken() != revsST.TT_EOF)
            token.addElement( new Double(revsST.nval) );
        revsIS.close();

        //statusSpeed = ((Double)token.elementAt(0)).doubleValue();
        statusAccel = ((Double)token.elementAt(0)).doubleValue();
        if (statusSpeed < 700) {
          statusSpeed += statusAccel;
        } else {
          statusSpeed -= statusAccel;
        }
        statusPos   = ((Double)token.elementAt(1)).doubleValue();

        //System.out.print   ("Speed: " + statusSpeed);
        //System.out.println ("Pos  : " + statusPos);

      } catch (IOException e) {
        System.out.println("Connection failed: " + URLstring);
      }
    } catch (MalformedURLException e) {
      System.out.println("Bad URL: " + URLstring );
    }

  }
}
