#!/usr/bin/perl
#
#    Copyright (C) 1999 by Dirk Wallmeier
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    This module inherited from the Webmin Module Template 0.79.1 by tn

require './afbackup-lib.pl';
&ReadParse();
#$conf = &get_config();
my $file = $config{'optionS'}.$in{'server'};
my ($vardir,$set_vardir) = &get_backup_conf_value ($file, "VarDirectory");

my ($all_sets, $all_sets_SET) = &get_backup_conf_value ($file, "Cartridge-Sets");
my @numsets = split (/ /, $all_sets);

my @numlists = ();
foreach $numset (@numsets) { push (@numlists, [&numset2list($numset)]); }


#%access = &get_module_acl();
#&can_edit_zone(\%access, $conf->[$in{'index'}]->{'value'}) ||
#	&error($text{'master_ecannot'});
#$access{'file'} || &error($text{'text_ecannot'});

&header("Needed Tapes", "", "Server_Conf");
print "<center><font size=+1>$file</font></center>\n";
print "<hr>\n";

## put in ACL checks here if needed

my %cartorder = ();
#open (CARTORDER, "/tmp/cartridge_order") or print "Fehler: /tmp/cartridge_order";
open (CARTORDER, $vardir."/cartridge_order") or print "Fehler: $vardir/cartridge_order<br>";
foreach (<CARTORDER>) { /(.*) -> (\d*)/ ; $cartorder{$1} = $2;  }
close (CARTORDER);

my %tape_uses = ();
#open (TAPEUSES, "/tmp/cartridge_order") or print "Fehler: /tmp/cartridge_order";
open (TAPEUSES, $vardir."/tape_uses") or print "Fehler: $vardir/tape_uses<br>";
foreach (<TAPEUSES>) { /(\d+): (\d+)/ ; $tape_uses{$1} = $2;  }
close (TAPEUSES);

#open (TAPEUSES, "/tmp/cartridge_order") or print "Fehler: /tmp/cartridge_order";
open (ROTAPES, $vardir."/readonly_tapes") or print "Fehler: $vardir/readonly_tapes<br>";
$ro_tapes = <ROTAPES>;
close (ROTAPES);

my @prectapes = ();
#open (PRECTAPES, "/tmp/precious_tapes") or print "Fehler: /tmp/precious_tapes";
open (PRECTAPES, $vardir."/precious_tapes") or print "Fehler: $vardir/precious_tapes<br>";
foreach (<PRECTAPES>) { push (@prectapes, [split (/ /, $_)]); }
close (PRECTAPES);



## sanity checks

#print $conf_file;
#print &get_backup_conf_value ($file, "ServerIdentifier")."\n";
print "<hr>\n";

#print $all_sets;

print "<table border cellpadding=3>\n";

print "<tr $tb><td ALIGN=RIGHT><b>Sets</b></td>";
for  $i (0 .. $#numsets) {
        my $n = $#{$numlists[$i]} +1;
        print  "<td ALIGN=CENTER COLSPAN=\"$n\" ><b>".($i+1)."</b>&nbsp;(".$numsets[$i].")</td> ";
}
print "</tr>";

print "<tr $tb>";
print "<td ALIGN=RIGHT ><b>Tapes</b></td>";
foreach $numlist (@numlists) {
    foreach $i ( @$numlist ) {
        print "<td><b> $i </b></td> ";   #VALIGN=TOP ROWSPAN=\"2\"
    }
}
print "</tr>\n";

#print "<tr $tb><td><b>Backup Nr</b></td></tr>";

#    cartridge_order
print "<tr $cb>";
print "<td ALIGN=RIGHT ><b>".&html_escape("->")."</b></td>";
foreach $numlist (@numlists) {
    foreach $i ( @$numlist ) {
        print "<td> ".(exists $cartorder{$i} ? $cartorder{$i} :"&nbsp;")." </td> ";
    }
}
print "</tr>\n";

print "<tr $cb>";
print "<td ALIGN=RIGHT ><b>Read Only</b></td>";
foreach $numlist (@numlists) {
    foreach $i ( @$numlist ) {
        print ((&isinset($ro_tapes, $i)) ? "<td bgcolor=red> &nbsp;" : "<td> &nbsp;")." </td> ";
    }
}
print "</tr>\n";

#   tape_uses
print "<tr $cb>";
print "<td ALIGN=RIGHT ><b>Tape Uses</b></td>";
foreach $numlist (@numlists) {
    foreach $i ( @$numlist ) {
        print "<td> ".(exists $tape_uses{$i} ? $tape_uses{$i} :"&nbsp;")." </td> ";
    }
}
print "</tr>\n";

print "<tr $cb>";
print "<td ALIGN=RIGHT ><b>Bytes on Tape</b></td>";
foreach $numlist (@numlists) {
    foreach $i ( @$numlist ) {
        print "<td> &nbsp; </td> ";
    }
}
print "</tr>\n";

#  precious_tapes
foreach $pt (@prectapes) {
    my ($host, $precset) =  @$pt;
    #my $host="dummy"; my $precset =  "20";
    print "<tr $cb>";
    print "<td ALIGN=RIGHT ><code>$host</code></td><font type=arial,helvetica>";
    foreach $numlist (@numlists) {
        foreach $i ( @$numlist ) {
            print ((&isinset($precset, $i)) ? "<td bgcolor=green> &nbsp;" : "<td> &nbsp;")." </td> ";
        }
    }
    print "</font></tr>\n";
}


#foreach $numset (split (/ /, $all_sets) ) {
#    for $j ( &numset2list($numset) ) {
#        print "<td $tb><b> $j </b></td> ";
#        for ($i=1 ; $i <= 8 ; $i++) {
#                print "<td $cb><b> &nbsp;&nbsp;&nbsp; </b></td> ";
#        }
#        print "</tr>\n";
#    }
#}

print "</table>\n";

print "<hr>\n";


&footer("/AFBackup/server.cgi?server=$in{'server'}", "Server");
# uses the index entry in /lang/en



## if subroutines are not in an extra file put them here


### END of index.cgi ###.
